<!DOCTYPE html>
<html>
<head>
    <title>TaiLung : Tiger Log Analysis Tool</title>
    <style type="text/css">
      .mybox {
        border: 0.4em ridge gray;
      }
      .emptymybox {
        border: 0.4em ;
      }

      .mybox2 {
        border: thick ridge gray;
      }
    </style>
</head>
<body onresize="resize_canvas()" onload="resize_canvas()" onkeypress="KeyFunction()">
<div class="container">
    <h4>Select Log File for analysis </h4>
    <form method="post" action="http://localhost:11180/upload" enctype="multipart/form-data">
        <fieldset>
            <input type="file" name="image" id="upload_files" multiple="multiple">
            <input type="submit" name="submit" value="Start Upload">
        </fieldset>
    </form>
</div>
<div class="emptymybox">
    <h4>Analysis Report   [KeyMap : z, x, a, s]</h4>
</div>
<div class="mybox">
    <canvas id="whole_canvas" width="10000" height="40" style="border:1px solid #000000;">
    </canvas>
    <p>Main : </p>
    <canvas id="main_canvas" width="10000" height="80" style="border:1px solid #000000;">
    </canvas>

    <p>Radio : </p>
    <canvas id="radio_canvas" width="10000" height="80" style="border:1px solid #000000;">
    </canvas>

    <p>Memory : </p>
    <canvas id="memory_canvas" width="10000" height="80" style="border:1px solid #000000;">
    </canvas>

	<p>Network : </p>
    <canvas id="network_canvas" width="10000" height="80" style="border:1px solid #000000;">
    </canvas>

    <script> 
    var curlinenumber = {{.MaxMarkCount}};
    var endPoint = {{.MaxMarkCount}};
    var screencurlinenumber= {{.MaxMarkCount}};
    var markcount = {{.MarkCount}};
    
    var jbAry = new Array();
    var mainintary = new Array();
    var mainstring = new Array();
    var maindescrstring = new Array();
    var maincolor = new Array();
    var radiointary = new Array();

    mainintary = {{ .MainNumber}};
    radiointary = {{ .RadioNumber}};
    mainstringary = {{ .MainString}};
    maindescrstring = {{ .MainDescString}};
    maincolor = {{ .MainColor}};
	jbAry = {{ .Number1 }};

    
    //mainintary[100] =10;
    //mainintary[200] =10;
    //jbAry=[100,100,100];

    </script>
    <script type="text/javascript">
    var foldervar = 1;
    var startPoint = 0;

    var mouse_x=0;
    var mouse_y=0;
    var canvars_width=0;
    var cMain = document.getElementById("main_canvas");
    var cRadio = document.getElementById("radio_canvas");
    var cMemory = document.getElementById("memory_canvas");
    var cWhole = document.getElementById("whole_canvas");
    cMain.onmousemove = function (event) {onMouseMain(event); };
    cWhole.onclick = function (event) {onclickwhole(event); };

    function onclickwhole(e) {
        var x = e.clientX-14;
        var y = e.clientY;
        var drawscreenwidth = endPoint - startPoint;
        var folder = curlinenumber/screencurlinenumber;

        console.log("Click",x,y,curlinenumber,screencurlinenumber);
        console.log("Folder",folder);
        console.log("startPoint=",startPoint);
        console.log("endPoint=",endPoint);
        console.log("drawwidth=",drawscreenwidth);
        startPoint = parseInt(x * folder);
        endPoint = startPoint + drawscreenwidth
        //endPoint = parseInt(x * folder);

        if (endPoint >= curlinenumber ) {
            endPoint = curlinenumber;
        }

        console.log("After Click");
        console.log("startPoint=",startPoint);
        console.log("endPoint=",endPoint);
        resize_canvas(); 
    }

    function onMouseMain(e) {
          var x = e.clientX-14;
          var y = e.clientY;
          mouse_x = x;
          mouse_y = y;
          var folder = (endPoint - startPoint)/screencurlinenumber;
          //console.log(x,y);

          for(var i=0;i<markcount;i++) {
            if (mainintary[i] == -1) {
                break;
            }
            
            if ( mainintary[i] > startPoint && mainintary[i] < endPoint ) {
                //console.log(parseInt((mainintary[i] - startPoint)/folder),x);
                if (parseInt((mainintary[i] - startPoint)/folder) == x )  {
                    console.log("Highlitgt",x,y);
                }
            }
        }
    }

    function Drar_canvas(){
        draw_whole();
        draw_main();
    }

    function draw_whole() {
        var folder = curlinenumber/screencurlinenumber;
        var c = document.getElementById("whole_canvas");
        var ctx = c.getContext("2d");
        
        for(var i=0;i<markcount;i++) {
            if (mainintary[i] == -1) {
                break;
            }
            ctx.beginPath();
            ctx.strokeStyle = maincolor[i];
            ctx.moveTo(parseInt(mainintary[i]/folder), 0);
            ctx.lineTo(parseInt(mainintary[i]/folder), 100);
            ctx.lineWidth = "2";
            ctx.stroke();
        }
        
        var cty = c.getContext("2d");
        cty.beginPath();
        cty.strokeStyle = "blue";
        cty.lineWidth = "2";
        cty.rect(parseInt(startPoint/folder),0, parseInt(endPoint/folder)-parseInt(startPoint/folder),40);
        cty.stroke();
    }

    function draw_main() {
        var c = document.getElementById("main_canvas");
        var pressfolder = parseInt((endPoint - startPoint) /10);
        var folder = (endPoint - startPoint)/screencurlinenumber;
        //console.log("Draw start =",startPoint,endPoint,screencurlinenumber,folder);
        //console.log(mainstringary[0]);
      
        var ctx = c.getContext("2d");
        ctx.beginPath();
        // console.log("pressfolder=",pressfolder,startPoint,endPoint);
        if (pressfolder > 0) {
            for(var i=startPoint;i<endPoint;i=i+pressfolder) {
                ctx.strokeStyle = "blue";
                ctx.font = "10px Arial";
                //console.log("===>",i,startPoint,i-startPoint,parseInt((i-startPoint)/folder));
                ctx.fillText(i.toString(),parseInt((i-startPoint)/folder),10);
                ctx.moveTo(parseInt((i-startPoint)/folder), 10);
                ctx.lineTo(parseInt((i-startPoint)/folder), 20);
                ctx.lineWidth = "2";
             }
        }
        ctx.stroke();
        var cty = c.getContext("2d");
        
        for(var i=0;i<markcount;i++) {
            if (mainintary[i] == -1) {
                break;
            }
            if ( mainintary[i] > startPoint && mainintary[i] < endPoint ) {
                cty.beginPath();
                ctx.strokeStyle = maincolor[i];
                cty.font = "12px Arial";
                cty.fillText(maindescrstring[i],
                (parseInt((mainintary[i] - startPoint)/folder))-(maindescrstring[i].length/2)*4,30);
                
                cty.moveTo(parseInt((mainintary[i] - startPoint)/folder), 35);
                cty.lineTo(parseInt((mainintary[i] - startPoint)/folder), 100);
                cty.lineWidth = "2";
                //console.log("Draw mark =",parseInt((mainintary[i] - startPoint)/folder));
                cty.stroke();
            }
        }
        
    } 

    function resize_canvas(){
        if (window.innerWidth > 100) {
            screencurlinenumber = window.innerWidth -50;
            var canvas = document.getElementById("main_canvas");
            var canvas1 = document.getElementById("radio_canvas");
            var canvas2 = document.getElementById("memory_canvas");
            var canvas3 = document.getElementById("network_canvas");
            var canvas4 = document.getElementById("whole_canvas");
             canvas.width  = window.innerWidth -50;
             canvas1.width  = window.innerWidth -50;
             canvas2.width  = window.innerWidth -50;
             canvas3.width  = window.innerWidth -50;
             canvas4.width  = window.innerWidth -50;
             canvars_width = canvas.width;       
        }else {
            //canvars_width = canvas.width = 100;
        }
        Drar_canvas();
    }

    function KeyFunction(){
        var pressfolder = parseInt((endPoint - startPoint) /10);

        if (pressfolder<30) {
            pressfolder = 30;
        }
        
        console.log("before press =", startPoint, endPoint,pressfolder);

        if(event.keyCode == 90 || event.keyCode == 122 ){   
            console.log("z press",event.keyCode);
            var rigth_ratio1 = Math.abs((canvars_width/2) - mouse_x)/(canvars_width/2);
           
            if (mouse_x >= (canvars_width/2)) {
                pressfolder1 = pressfolder * (1+rigth_ratio1);
                pressfolder2 = pressfolder * (1-rigth_ratio1);
            }else {
                pressfolder1 = pressfolder * (1-rigth_ratio1);
                pressfolder2 = pressfolder * (1+rigth_ratio1);
            }

            console.log("z press ",mouse_x, rigth_ratio1, pressfolder1, pressfolder2 );

            if ( (endPoint - startPoint) > canvars_width ) {
                if ((startPoint + pressfolder2) <=  endPoint) {
                    startPoint = parseInt(startPoint + pressfolder1);
                }
                if ((endPoint - pressfolder2) >= startPoint ) {
                    endPoint = parseInt(endPoint - pressfolder2);
                }
            }
            resize_canvas();
        }else if(event.keyCode == 80 || event.keyCode == 120 ){
            console.log("x press",event.keyCode);
            var rigth_ratio1 = Math.abs((canvars_width/2) - mouse_x)/(canvars_width/2);

            if (mouse_x >= (canvars_width/2)) {
                pressfolder1 = pressfolder * (1+rigth_ratio1);
                pressfolder2 = pressfolder * (1-rigth_ratio1);
            }else {
                pressfolder1 = pressfolder * (1-rigth_ratio1);
                pressfolder2 = pressfolder * (1+rigth_ratio1);
            }


            if ((startPoint - pressfolder1) >  0) {
                startPoint = parseInt(startPoint - pressfolder1);
            } else {
                startPoint = 0x00;
            }

            if ((endPoint + pressfolder2) < curlinenumber ) {
                endPoint = parseInt(endPoint + pressfolder2);
            }  else {
                endPoint = curlinenumber;
            }
            resize_canvas();
        }else if (event.keyCode == 65 || event.keyCode == 97 ) {
            console.log("a press",event.keyCode); 
            if (startPoint > 0x00) {
                if (startPoint < pressfolder) {
                    startPoint = 0x00;
                }else {
                    startPoint = parseInt(startPoint - pressfolder);
                }
                if (endPoint > 0x00) {
                    if (endPoint < pressfolder) {
                        endPoint = parseInt(pressfolder);
                    }else {
                        endPoint = parseInt(endPoint - pressfolder);
                    }
                }
            }
            resize_canvas();
        }else if (event.keyCode == 83 || event.keyCode == 115 ) {
            console.log("s press",event.keyCode);
            if (endPoint < curlinenumber) {
                if ( (startPoint + pressfolder) <= curlinenumber){
                    startPoint = parseInt(startPoint + pressfolder);
                }
                if ((endPoint+30) <= curlinenumber ){
                    endPoint = parseInt(endPoint + pressfolder);
                }else {
                    endPoint = parseInt(curlinenumber);
                }
            }
            resize_canvas();
        }

        console.log("after press =", startPoint, endPoint);
    }
    </script>
</div>
</body>
</html>
